--[[ **************************************************************************
     *  Add On Dependencies version checks                                    *
	 **************************************************************************
]]
local VerLockOut = true
local BillsUtilsReqVer = {string.split("-", GetAddOnMetadata("NickAlert", "X-BillsUtilsReqVer")) }
local BillsUtilsCurVer = {string.split("-", GetAddOnMetadata("BillsUtils", "Version")) }

if BillsUtilsCurVer[1] > BillsUtilsReqVer[1] then
	VerLockOut = false
else
	if BillsUtilsCurVer[2] > BillsUtilsReqVer[2] then
		VerLockOut = false
	else
		if BillsUtilsCurVer[3] >= BillsUtilsReqVer[3] then
			VerLockOut = false
		end
	end
end
	

if not(VerLockOut) then
	
NAlert = {}
local loaded = false



-- Config Panel Text Strings
NAlert.Text={
Title = "Nick Alert",
TitleSub = "Change how Nick Alert behaves by setting the options below",
Enable = "Enable the Add On to function",
Guild = "Scan Guild channel",
Party = "Scan Party channel",
Say  = "Scan Say channel",
Yell = "Scan Yell channel",
Emotes = "Scan Emotes",
BGs = "Scan Battleground channel",
Raid = "Scan Raid channel",
Chats = "Scan Other channels",
ChatDebug = "Print all matches to default chat log",
MSBT  = "Enable output to MSBT's notification frame",
Sound = "Enable sound to notify you of an achievement",
CustomMP3 = "Enable custom alert.mp3 sound",
CustomOGG = "Enable custom alert.ogg sound",
Throttle = "Enable alert throttle",
ThrottleTime = "Amount of time to throttle over",
ThrottleAmount = "Max number of alerts in above time"
}

-- Local text colors
local yel = "|cFFFFFF00"
local wht = "|cFFFFFFFF"
local blu = "|cFF00FFFF"
local red = "|cFFFF0000"
local grn = "|cFF00FF00"
local res = "|r"



-- Bill's Utils
local Wait = BillsUtils.Wait
local ChkBox = BillsUtils.ChkBox
local ChkBoxSave = BillsUtils.ChkBoxSave
local CheckClick = BillsUtils.CheckClick
local SliderSave = BillsUtils.SliderSave
local SliderMW = BillsUtils.SliderMW
local Slider = BillsUtils.Slider
local SliderEditBox = BillsUtils.SliderEditBox
local SJprint = BillsUtils.SJprint



-- General Settings / functions
NAlert.Checkclick = function()
	PlaySound( "GAMEGENERICBUTTONPRESS" )
end

--Panel
NAlert.panel = CreateFrame( "Frame", "NAlertConfig", UIParent )
NAlert.panel2 = CreateFrame( "Frame", "NAlertConfig2", NAlert.panel )
local me = NAlert.panel
local me2 = NAlert.panel2
me:SetScript("OnLoad", function()
	NAlert.init()
end)


me.name = "Nick Alert"
me2:SetSize(380,475)
me2:SetPoint("BOTTOMLEFT", me, "BOTTOMLEFT")


local X = 16 -- standard Horizontal Spacing
local Y = 35 -- standard Vertical spacing 26
local TxtY = 13

-- Pane title
	local Title = me:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
	Title:SetPoint( "TOPLEFT", 16, -16 )
	Title:SetText( NAlert.Text.Title )
	local SubText = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	SubText:SetPoint( "TOPLEFT", Title, "BOTTOMLEFT", 0, -8 )
	SubText:SetPoint( "RIGHT", -32, 0 )
	SubText:SetHeight( 32 )
	SubText:SetJustifyH( "LEFT" )
	SubText:SetJustifyV( "TOP" )
	SubText:SetText( NAlert.Text.TitleSub )

-- Scroll Frame
	me.ScrollFrame = CreateFrame("ScrollFrame", "NAlertConfigScrollFrame", me, "UIPanelScrollFrameTemplate")
	me.ScrollFrame:SetScrollChild(me2)
	me.ScrollFrame:SetPoint("TOPRIGHT", me ,"TOPRIGHT", -30,- 64)
	me.ScrollFrame:SetPoint("BOTTOMRIGHT", me ,"BOTTOMRIGHT", -30, 10)
	me.ScrollFrame:SetSize(390, 400)


-- Check Boxes & Text
	local last = me2
	local Command = {"Enable", "Guild", "Party", "BGs", "Raid", "Say", "Yell", "Emotes",
	"Chats", "ChatDebug", "MSBT", "Sound", "CustomMP3", "CustomOGG", "Throttle"}

	for x = 1, #Command do
		me[ Command[x] ] = ChkBox( last , "NicKAlertCfg", Command[x] , me2, CheckClick, NAlert.Text )
		last = me[ Command[x] ]
	end
	

-- Throttle Time Slider	and EditBox
	me.ThrottleTime = Slider( last , "NickAlertCfg", "ThrottleTime", me2 , SliderMW , NAlert.Text, 0, 60, 1 )
	last = me.ThrottleTime
	me.ThrottleTime.Val = SliderEditBox( last , "NickAlertCfg", "ThrottleTime", me2 )
	
-- Throttle Amount Slider
	me.ThrottleAmount = Slider( last , "NickAlertCfg", "ThrottleAmount", me2 , SliderMW , NAlert.Text, 0, 60, 1 )
	last = me.ThrottleAmount
	me.ThrottleAmount.Val = SliderEditBox( last , "NickAlertCfg", "ThrottleAmount", me2 )
	
--	End of frame



-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- X  Init / Reset the config panel to match current settings                                                     X
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--


NAlert.Init = function(...)
	
	local setting = NA_Settings
	local me = NAlert.panel

	me.Enable:SetChecked( setting.Enable )
	me.Guild:SetChecked( setting.Guild )
	me.Party:SetChecked( setting.Party )
	me.BGs:SetChecked( setting.BGs )
	me.Raid:SetChecked( setting.Raid )
	me.Say:SetChecked( setting.Say )
	me.Yell:SetChecked( setting.Yell )
	me.Emotes:SetChecked( setting.Emotes )
	me.Chats:SetChecked( setting.Chats )
	me.ChatDebug:SetChecked( setting.ChatDebug )
	me.MSBT:SetChecked( setting.MSBT )
	me.Sound:SetChecked( setting.Sound )
	me.CustomMP3:SetChecked( setting.CustomMP3 )
	me.CustomOGG:SetChecked( setting.CustomOGG )
	me.Throttle:SetChecked( setting.Throttle )
	me.ThrottleTime:SetValue( setting.ThrottleTime)
	me.ThrottleTime.Val:SetCursorPosition( 0 )
	me.ThrottleTime.Val:SetNumber( setting.ThrottleTime )
	me.ThrottleAmount:SetValue( setting.ThrottleAmount)
	me.ThrottleAmount.Val:SetCursorPosition( 0 )
	me.ThrottleAmount.Val:SetNumber( setting.ThrottleAmount )
end

-- Reset config panel and settings to DEFAULT
NAlert.Reset = function(...)
	local def = NA_Defaults
	local cur = NA_Settings

	cur.Enable = def.Enable
	cur.Guild = def.Guild
	cur.Party = def.Party
	cur.BGs = def.BGs
	cur.Raid = def.Raid
	cur.Say = def.Say
	cur.Yell = def.Yell
	cur.Emotes = def.Emotes
	cur.Chats = def.Chats
	cur.ChatDebug = def.ChatDebug
	cur.MSBT = def.MSBT
	cur.Sound = def.Sound
	cur.CustomMP3 = def.CustomMP3
	cur.CustomOGG = def.CustomOGG
	cur.Throttle = def.Throttle
	cur.ThrottleTime = def.ThrottleTime
	cur.ThrottleAmount = def.ThrottleAmount
	
	NAlert.Init()
end



me.refresh = function(self)
	NAlert.Init()
end

me.default = function (self)
	NAlert.Reset()
end

me.cancel = function (self)
	NAlert.Init()
end


-- Save settings from config panel
me.okay = function(self)
	ChkBoxSave( NAlert.panel, "Enable", NA_Settings) -- Enable CheckBox
	ChkBoxSave( NAlert.panel, "Guild", NA_Settings) -- Guild CheckBox
	ChkBoxSave( NAlert.panel, "Party", NA_Settings) -- Party CheckBox
	ChkBoxSave( NAlert.panel, "Say", NA_Settings) -- Say CheckBox
	ChkBoxSave( NAlert.panel, "Yell", NA_Settings) -- Yell CheckBox
	ChkBoxSave( NAlert.panel, "Emotes", NA_Settings) -- Emotes CheckBox
	ChkBoxSave( NAlert.panel, "BGs", NA_Settings) -- BGs CheckBox
	ChkBoxSave( NAlert.panel, "Chats", NA_Settings) -- Chats CheckBox
	ChkBoxSave( NAlert.panel, "ChatDebug", NA_Settings) -- ChatDebug CheckBox
	ChkBoxSave( NAlert.panel, "MSBT", NA_Settings) -- MSBT CheckBox
	ChkBoxSave( NAlert.panel, "Sound", NA_Settings) -- Sound CheckBox
	ChkBoxSave( NAlert.panel, "CustomMP3", NA_Settings) -- CustomMP3 CheckBox
	ChkBoxSave( NAlert.panel, "CustomOGG", NA_Settings) -- CustomOGG CheckBox
	ChkBoxSave( NAlert.panel, "Throttle", NA_Settings) -- Throttle CheckBox
	SliderSave( NAlert.panel, "ThrottleTime", NA_Settings) -- Throttle Time Slider
	SliderSave( NAlert.panel, "ThrottleAmount", NA_Settings) -- Throttle Amount Slider

	NickAlert.EventManager()
end

-- Register the config panel
InterfaceOptions_AddCategory( me )

-- ****************************************************************************
-- * Nick Name Child Panel                                                    *
-- ****************************************************************************

--Panel
NAlert.panel3 = CreateFrame( "Frame", "NAlertConfig", UIParent )
local me = NAlert.panel3
me.NNButtons = {}

me.name = "Nick Names"
me.parent = NAlert.panel.name

local X = 16 -- standard Horizontal Spacing
local Y = 35 -- standard Vertical spacing 26
local TxtY = 13
local e = 0

NAlert.EBoxUpdate = function(count)
	local NA = NickAlert.NNTable
	local maxcount = #NA.Nicks
	local slider = me.slider:GetValue()
	
	if count + slider > maxcount then
		me.EBox:SetText("")
	else
		me.EBox:SetText(NA.Nicks[count + slider])
	end
end


NAlert.NNDisplayUpdate = function()
	local NA = NickAlert.NNTable
	local maxcount = #NA.Nicks
	local slider = me.slider:GetValue()
	
	
	for x = 1 , 10 do
		if x + slider > maxcount then
			me.NNButtons[x]:SetText( " " )
		else
			me.NNButtons[x]:SetText( NA.Nicks[x + slider] )
		end
	end
	me.slider:SetMinMaxValues( 0, (#NA.Nicks > 10 and #NA.Nicks - 10) or 1 )
end


-- Pane title
local Title = me:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
Title:SetPoint( "TOPLEFT", 16, -16 )
Title:SetText( "Nick Names" )
local SubText = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
SubText:SetPoint( "TOPLEFT", Title, "BOTTOMLEFT", 0, -8 )
SubText:SetPoint( "RIGHT", -32, 0 )
SubText:SetHeight( 32 )
SubText:SetJustifyH( "LEFT" )
SubText:SetJustifyV( "TOP" )
SubText:SetText( "Setup your aliases here"  )
	
local last = me
local width = 150 --me:GetWidth() /2

for x = 1, 10 do
	me.NNButtons[x] = CreateFrame("Button", "NAlertListButton"..tostring(x), me, "UIPanelButtonTemplate" )
	if last == me then
		me.NNButtons[x]:SetPoint("TOPLEFT", last, "TOPLEFT", 20, -60 )
	else
		me.NNButtons[x]:SetPoint("TOPLEFT", last, "BOTTOMLEFT" )
	end
	me.NNButtons[x]:SetSize( width , 20)
	me.NNButtons[x]:SetText( " " )
	me.NNButtons[x].count = x
	me.NNButtons[x]:SetScript("OnClick", function(self, button, down)
		if (button ~= "LeftButton") then
			return
		end
		PlaySound( "GAMEGENERICBUTTONPRESS" )
		NAlert.EBoxUpdate( self.count )
		return
	end)
	last = me.NNButtons[x]
end

me.slider = CreateFrame( "Slider", "NAlertNNListSlider", me, "OptionsSliderTemplate" )
me.slider:SetMinMaxValues( 0, 1 )
me.slider:SetOrientation("VERTICAL")
me.slider:SetPoint("TOPLEFT", me.NNButtons[1] ,"TOPRIGHT", 5 , 0)
me.slider:SetPoint("BOTTOMLEFT", me.NNButtons[10] ,"BOTTOMRIGHT", 5 , 0)
me.slider:SetValueStep( 1 )
--	slider:SetWidth( 240 )
--	slider:SetHeight( 16 )
me.slider:SetWidth( 16 )	
me.slider:SetScript( "OnValueChanged", function( self )
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	NAlert.NNDisplayUpdate()
end)
getglobal(me.slider:GetName() .. 'Low'):SetText( " " )
getglobal(me.slider:GetName() .. 'High'):SetText( " " )
--	getglobal(slider:GetName() .. 'Text'):SetText(TextTable[ Name ]); --Sets the "title" text (top-centre of slider).
me.slider:SetScript("OnMouseWheel", function(self, delta)
	SliderMW(self, -delta)
end)

me.EBox = CreateFrame( "EditBox", "NAlertNNEditbox", me, "InputBoxTemplate" )
me.EBox:SetFontObject("ChatFontNormal")
me.EBox:SetTextInsets(0, 0, 3, 3)
me.EBox:SetPoint("BOTTOMLEFT", me , "BOTTOMLEFT", 30 , 50 )
me.EBox:SetPoint("RIGHT", -32, 0)
me.EBox:SetHeight(19)
me.EBox:SetWidth(50)
me.EBox:SetAutoFocus(false)
me.EBox:SetMaxLetters( 254 )
me.EBox:SetScript("OnEnterPressed" , function(self)
	self:ClearFocus()
end)
me.EBox:SetScript("OnEscapePressed", function(self)
	self:SetText( "" )
	self:ClearFocus()
end)

me.EBox.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
me.EBox.Text:SetPoint( "BOTTOMLEFT", me.EBox , "BOTTOMLEFT", 0 , Y/4 )
me.EBox.Text:SetPoint( "RIGHT", -32, 0 )
me.EBox.Text:SetHeight( 32 )
me.EBox.Text:SetJustifyH( "LEFT" )
me.EBox.Text:SetJustifyV( "TOP" )
me.EBox.Text:SetText( "Enter Nick or click one above" )

me.AddButton = CreateFrame("Button", "NalertAddButton", me, "UIPanelButtonTemplate" )
me.AddButton:SetPoint("BOTTOMLEFT", me, "BOTTOMLEFT", 20 , 20 )
me.AddButton:SetSize( 150, 25)
me.AddButton:SetText("Add")
me.AddButton:SetScript("OnClick", function(self, button, down)
	if (button ~= "LeftButton") then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	NickAlert.Add( me.EBox:GetText() )
	me.EBox:SetText("")
	me.EBox:ClearFocus()
	NAlert.NNDisplayUpdate()
	return
end)

me.DeleteButton = CreateFrame("Button", "NAlertDeleteButton", me, "UIPanelButtonTemplate" )
me.DeleteButton:SetPoint("BOTTOMRIGHT", me, "BOTTOMRIGHT", -20 , 20 )
me.DeleteButton:SetSize( 150, 25)
me.DeleteButton:SetText("Delete")
me.DeleteButton:SetScript("OnClick", function(self, button, down)
	if (button ~= "LeftButton") then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	NickAlert.Rem( me.EBox:GetText() )
	me.EBox:SetText("")
	me.EBox:ClearFocus()
	NAlert.NNDisplayUpdate()
	return
end)

me.refresh= function( self )
	me.slider:SetValue(0)
	NAlert.NNDisplayUpdate()
end


InterfaceOptions_AddCategory( me )

end -- end of huge VerLockOut if so addon doesn't load if Bill's Utils is out of date

